#booster
function sette:mechanic/booster

#lucky block
function sette:mechanic/lucky_block

#item replace armorstand
item replace entity @e[type=armor_stand,tag=lucky_block] armor.head with yellow_concrete

#detect when someone isn't on their horse
function sette:mechanic/riding/detect

#powerup giving timing
execute as @a if score @s powerup matches 45 run item replace entity @s hotbar.0 from entity @s inventory.18
execute as @a if score @s powerup matches 40 run item replace entity @s hotbar.1 from entity @s inventory.19
execute as @a if score @s powerup matches 35 run item replace entity @s hotbar.2 from entity @s inventory.20
execute as @a if score @s powerup matches 30 run item replace entity @s hotbar.3 from entity @s inventory.21
execute as @a if score @s powerup matches 25 run item replace entity @s hotbar.4 from entity @s inventory.22
execute as @a if score @s powerup matches 20 run item replace entity @s hotbar.5 from entity @s inventory.23
execute as @a if score @s powerup matches 15 run item replace entity @s hotbar.6 from entity @s inventory.24
execute as @a if score @s powerup matches 10 run item replace entity @s hotbar.7 from entity @s inventory.25
execute as @a if score @s powerup matches 5 run item replace entity @s hotbar.8 from entity @s inventory.26

execute as @a at @s if score @s powerup matches 45 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2
execute as @a at @s if score @s powerup matches 40 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2
execute as @a at @s if score @s powerup matches 35 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2
execute as @a at @s if score @s powerup matches 30 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2
execute as @a at @s if score @s powerup matches 25 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2
execute as @a at @s if score @s powerup matches 20 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2
execute as @a at @s if score @s powerup matches 15 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2
execute as @a at @s if score @s powerup matches 10 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2
execute as @a at @s if score @s powerup matches 5 run playsound minecraft:block.dispenser.dispense master @s ~ ~ ~ 100 2

execute as @a if score @s powerup matches 1.. run scoreboard players remove @s powerup 1

#powerup
function sette:mechanic/powerup/ink
function sette:mechanic/powerup/lightning
function sette:mechanic/powerup/speed
function sette:mechanic/powerup/jump
function sette:mechanic/powerup/nausea
function sette:mechanic/powerup/curse

# laps and win detection
execute at @e[type=marker,tag=finish_line] as @a[tag=rider,dx=2,dz=24,dy=5,scores={checkpoint=41},gamemode=!spectator] run function sette:mechanic/lapped
execute as @a[tag=rider,gamemode=!spectator] at @s run function sette:mechanic/placing/checkpoint 

scoreboard players operation #current placement = #min placement
scoreboard players operation #decrement lap = #max lap

function sette:mechanic/placing/placement_recursion

tag @a[tag=rider,gamemode=!spectator] remove placed

# game over detection
execute if score remaining ticks matches 0 if score finished stats matches 1 run scoreboard players operation #current placement = #min placement
execute if score remaining ticks matches 0 if score finished stats matches 1 run function sette:mechanic/placing/final_place

#music
execute if score game stats matches 1 run function sette:mechanic/music/loop

#slow players when they touch structure void
execute as @a[scores={rider=1..}] at @s if block ~ ~ ~ structure_void run effect give @e[type=horse,sort=nearest,limit=1] slowness 2 1 true